#version 150
layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

//Can declare this as textures
uniform vec4[256] texCoordsByID;
uniform float[256] texLayersByID;

in vec2 wSize[];
in vec2 sSize[];
in float sTexture[];
in float sAngle[];
in vec4 sColor[];
out vec4 color;
out vec3 texcoord0;

void main() {
    color = sColor[0];
    
    float h = cos(sAngle[0]);
    float v = -sin(sAngle[0]);
    
    vec2 xx = vec2(h,v)*sSize[0].x;
    vec2 yy = vec2(-v,h)*sSize[0].y;
    
    int tInd = int(sTexture[0]);
    float layer = texLayersByID[tInd];
    
    texcoord0 = vec3(texCoordsByID[tInd].x,texCoordsByID[tInd].y,layer);
    gl_Position = gl_in[0].gl_Position + vec4(wSize[0]*(-xx-yy), 0, 0);
    EmitVertex();
    texcoord0 = vec3(texCoordsByID[tInd].z,texCoordsByID[tInd].y,layer);
    gl_Position = gl_in[0].gl_Position + vec4(wSize[0]*(xx-yy), 0, 0);
    EmitVertex();
    texcoord0 = vec3(texCoordsByID[tInd].x,texCoordsByID[tInd].w,layer);
    gl_Position = gl_in[0].gl_Position + vec4(wSize[0]*(-xx+yy), 0, 0);
    EmitVertex();
    texcoord0 = vec3(texCoordsByID[tInd].z,texCoordsByID[tInd].w,layer);
    gl_Position = gl_in[0].gl_Position + vec4(wSize[0]*(xx+yy), 0, 0);
    EmitVertex();

    EndPrimitive();
}